var __assign =
  (this && this.__assign) ||
  function () {
    __assign =
      Object.assign ||
      function (t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
          s = arguments[i]
          for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p]
        }
        return t
      }
    return __assign.apply(this, arguments)
  }
var __spreadArray =
  (this && this.__spreadArray) ||
  function (to, from, pack) {
    if (pack || arguments.length === 2)
      for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
          if (!ar) ar = Array.prototype.slice.call(from, 0, i)
          ar[i] = from[i]
        }
      }
    return to.concat(ar || Array.prototype.slice.call(from))
  }
import { ReDocUI, SwaggerUI } from './ui'
import { Router } from 'itty-router'
import { getFormatedParameters, Query } from './parameters'
export function OpenAPIRouter(options) {
  var OpenAPIPaths = {}
  var router = Router({ base: options.base, routes: options.routes })
  // @ts-ignore
  var routerProxy = new Proxy(router, {
    get: function (target, prop, receiver) {
      if (prop === 'original') {
        return router
      }
      return function (route) {
        var handlers = []
        for (var _i = 1; _i < arguments.length; _i++) {
          handlers[_i - 1] = arguments[_i]
        }
        if (prop !== 'handle') {
          if (prop !== 'all') {
            var parsedRoute = route.replace(/:(\w+)/g, '{$1}')
            var schema = undefined
            var operationId = undefined
            for (var _a = 0, handlers_1 = handlers; _a < handlers_1.length; _a++) {
              var handler = handlers_1[_a]
              if (handler.name) {
                operationId = prop.toString() + '_' + handler.name
              }
              if (handler.getParsedSchema) {
                schema = handler.getParsedSchema()
                break
              }
            }
            if (OpenAPIPaths[parsedRoute] === undefined) {
              // The same path can have multiple operations
              OpenAPIPaths[parsedRoute] = {}
            }
            if (operationId === undefined) {
              operationId = prop.toString() + '_' + route.replaceAll('/', '_')
            }
            if (schema === undefined) {
              // No schema for this route, try to guest the parameters
              var params = route.match(/:(\w+)/g)
              schema = {
                operationId: operationId,
                parameters: params
                  ? getFormatedParameters(
                      params.map(function (param) {
                        return Query(String, {
                          name: param.replace(':', ''),
                        })
                      })
                    )
                  : null,
              }
            }
            OpenAPIPaths[parsedRoute][prop.toString()] = __assign({ operationId: operationId }, schema)
          }
        }
        return Reflect.get(target, prop, receiver).apply(
          void 0,
          __spreadArray(
            [route],
            handlers.map(function (handler) {
              if (handler.isRoute === true) {
                return function () {
                  var _a
                  var params = []
                  for (var _i = 0; _i < arguments.length; _i++) {
                    params[_i] = arguments[_i]
                  }
                  return (_a = new handler()).execute.apply(_a, params)
                }
              }
              return handler
            }),
            false
          )
        )
      }
    },
  })
  if ((options === null || options === void 0 ? void 0 : options.config) !== undefined) {
    router.get('/docs', function () {
      return new Response(SwaggerUI, {
        headers: {
          'content-type': 'text/html; charset=UTF-8',
        },
        status: 200,
      })
    })
    router.get('/redocs', function () {
      return new Response(ReDocUI, {
        headers: {
          'content-type': 'text/html; charset=UTF-8',
        },
        status: 200,
      })
    })
    router.get('/openapi.json', function () {
      return new Response(
        JSON.stringify(
          __assign(__assign({}, options === null || options === void 0 ? void 0 : options.config), {
            paths: OpenAPIPaths,
          })
        ),
        {
          headers: {
            'content-type': 'application/json;charset=UTF-8',
          },
          status: 200,
        }
      )
    })
  }
  return routerProxy
}
